/*****************************************************************************
 *
 * Project name: 			Plank LFI REBA / Herschel PACS SPU
 * Product name: 			LLSW_DRV
 * Object name: 			l_pscint
 * Filename: 				l_pscint.h
 * Language: 				C (ADSP-21020)
 * Compiler: 				G21K - r3.3
 * Company: 				CRISA
 * Author: 					F. Torrero
 * Version: 				1
 * Creation date: 			03/Aug/2001
 * Last Modification date: 	04/06/2003 16:05:46
 *
 * Description ===============================================================
 *
 * This module implements functions related to management of interrupts for
 * Data memory PSC and Program Memory PSC.
 *
 * Change log ===============================================================
 *
 * | DATE 	  | NEW VERSION 	| AUTHOR 	  | 	REASON FOR CHANGE 	|
 * ===========================================================================
 *
 * 03/Aug/01 	1			 	 F.Torrero		Creation
 *
 * ****************************************************************************/ 


#ifndef L_PSCINT_H
#define L_PSCINT_H


/*****************************************************************************
   INCLUDES
*****************************************************************************/

#include "l_gendef.h"

/*****************************************************************************
   PROVIDED CONSTANTS
*****************************************************************************/


/*****************************************************************************
   PROVIDED TYPES
*****************************************************************************/


/*****************************************************************************
   PROVIDED VARIABLES
*****************************************************************************/


/*****************************************************************************
   DECLARATION OF PROVIDED FUNCTIONS
*****************************************************************************/

T_SR PSC_EnaDisPMPSCGlobalSubInt(T_UNSIGNED_32 EnableDisableFlag);

T_SR PSC_EnaDisDMPSCGlobalSubInt(T_UNSIGNED_32 EnableDisableFlag);

T_SR PSC_MaskUnmaskPMPSCSubInt(T_UNSIGNED_32 InterruptBitMask,
							   T_UNSIGNED_32 MaskUnmaskFlag);

T_SR PSC_MaskUnmaskDMPSCSubInt(T_UNSIGNED_32 InterruptBitMask,
							   T_UNSIGNED_32 MaskUnmaskFlag);

T_SR PSC_GetPMPSCIMR(T_UNSIGNED_32 *InterruptMaskRegValue);

T_SR PSC_GetDMPSCIMR(T_UNSIGNED_32 *InterruptMaskRegValue);

T_SR PSC_GetPMPSCIPR(T_UNSIGNED_32 *InterruptPendingRegValue);

T_SR PSC_GetDMPSCIPR(T_UNSIGNED_32 *InterruptPendingRegValue);

T_SR PSC_ClearPMPSCIPR(T_VOID);

T_SR PSC_ClearDMPSCIPR(T_VOID);

T_SR PSC_ClearPMPSCSUbInt(T_UNSIGNED_32 InterruptBitMask);

T_SR PSC_ClearDMPSCSUbInt(T_UNSIGNED_32 InterruptBitMask);


#endif  /* L_PSCINT_H */

