/***************************************************************************************
* File name: rangecod.h
* Version.Revision: HPSPU-HLSW-OB-V12R0
*
* Purpose:  Header for the range coder.
*
* Public Functions: None 
*
* Private Functions: None
*
* Description:	This file contains the declared parameters for the range coder.
*
* Creation date & author: 28.10.2004 by  Ahmed Nabil Belbachir
* Version, Update date & author: HPSPU-HLSW-OB-V12R1 18.01.2006 by Ahmed Nabil Belbachir
****************************************************************************************/

/* The Header Files 
===================================================================================================*/
#ifndef rangecod_h
#define rangecod_h


#include "genspu.h"

typedef unsigned int code_value;       
typedef unsigned int freq; 
typedef struct {
    u4 low,           /* low end of interval */
       range,         /* length of interval */
       help;          /* bytes_to_follow resp. intermediate value */
    u4 buffer;/* buffer for input/output */
/* the following is used only when encoding */
    u4 bytecount;     /* counter for outputed bytes  */
/* insert fields you need for input/output below this line! */
} rangecoder;


void start_encoding( rangecoder *rc, u4 c, int initlength);

void encode_freq( rangecoder *rc, freq sy_f, freq lt_f, freq tot_f );
void encode_shift( rangecoder *rc, freq sy_f, freq lt_f, freq shift );

#define encode_byte(ac,b)  encode_shift(ac,(freq)1,(freq)(b),(freq)8)
#define encode_short(ac,s) encode_shift(ac,(freq)1,(freq)(s),(freq)16)


unsigned int done_encoding( rangecoder *rc );

#endif
